diff --git a/oflog/libsrc/socketap.cc b/oflog/libsrc/socketap.cc
index 132fc4a..3e8c7db 100644
--- a/oflog/libsrc/socketap.cc
+++ b/oflog/libsrc/socketap.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,29 +18,27 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-//#include <cstdlib>
+#include <cstdlib>
 #include "dcmtk/oflog/socketap.h"
 #include "dcmtk/oflog/layout.h"
-#include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/sleep.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/thread/syncpub.h"
 
-#define INCLUDE_CSTDLIB
-#include "dcmtk/ofstd/ofstdinc.h"
 
-#define DCMTK_LOG4CPLUS_MESSAGE_VERSION 2
+namespace dcmtk {
+namespace log4cplus {
 
+int const DCMTK_LOG4CPLUS_MESSAGE_VERSION = 3;
 
-namespace dcmtk
-{
-
-namespace log4cplus
-{
 
 #if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
 SocketAppender::ConnectorThread::ConnectorThread (
     SocketAppender & socket_appender)
     : sa (socket_appender)
+    , trigger_ev ()
     , exit_flag (false)
 { }
 
@@ -56,14 +54,14 @@ SocketAppender::ConnectorThread::run ()
     {
         trigger_ev.timed_wait (30 * 1000);
 
-        getLogLog().debug (
+        helpers::getLogLog().debug (
             DCMTK_LOG4CPLUS_TEXT("SocketAppender::ConnectorThread::run()")
             DCMTK_LOG4CPLUS_TEXT("- running..."));
 
         // Check exit condition as the very first thing.
 
         {
-            thread::Guard guard (access_mutex);
+            thread::MutexGuard guard (access_mutex);
             if (exit_flag)
                 return;
             trigger_ev.reset ();
@@ -72,17 +70,18 @@ SocketAppender::ConnectorThread::run ()
         // Do not try to re-open already open socket.
 
         {
-            thread::Guard guard (sa.access_mutex);
+            thread::MutexGuard guard (sa.access_mutex);
             if (sa.socket.isOpen ())
                 continue;
         }
 
         // The socket is not open, try to reconnect.
 
-        helpers::Socket socket (sa.host, sa.port);
-        if (! socket.isOpen ())
+        helpers::Socket new_socket (sa.host,
+            OFstatic_cast(unsigned short, sa.port));
+        if (! new_socket.isOpen ())
         {
-            getLogLog().error(
+            helpers::getLogLog().error(
                 DCMTK_LOG4CPLUS_TEXT("SocketAppender::ConnectorThread::run()")
                 DCMTK_LOG4CPLUS_TEXT("- Cannot connect to server"));
 
@@ -97,8 +96,8 @@ SocketAppender::ConnectorThread::run ()
         // Connection was successful, move the socket into SocketAppender.
 
         {
-            thread::Guard guard (sa.access_mutex);
-            sa.socket = socket;
+            thread::MutexGuard guard (sa.access_mutex);
+            sa.socket = new_socket;
             sa.connected = true;
         }
     }
@@ -109,7 +108,7 @@ void
 SocketAppender::ConnectorThread::terminate ()
 {
     {
-        thread::Guard guard (access_mutex);
+        thread::MutexGuard guard (access_mutex);
         exit_flag = true;
         trigger_ev.signal ();
     }
@@ -130,11 +129,14 @@ SocketAppender::ConnectorThread::trigger ()
 // SocketAppender ctors and dtor
 //////////////////////////////////////////////////////////////////////////////
 
-SocketAppender::SocketAppender(const tstring& host_, int port_,
-    const tstring& serverName_)
-: host(host_),
+SocketAppender::SocketAppender(const tstring& host_,
+    unsigned short port_, const tstring& serverName_)
+: socket(),
+  host(host_),
   port(port_),
-  serverName(serverName_)
+  serverName(serverName_),
+  connected(false),
+  connector()
 {
     openSocket();
     initConnector ();
@@ -142,15 +144,17 @@ SocketAppender::SocketAppender(const tstring& host_, int port_,
 
 
 
-SocketAppender::SocketAppender(const helpers::Properties & properties, tstring&)
+SocketAppender::SocketAppender(const helpers::Properties & properties)
  : Appender(properties),
-   port(9998)
+   socket(),
+   host(),
+   port(9998),
+   serverName(),
+   connected(false),
+   connector()
 {
     host = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("host") );
-    if(properties.exists( DCMTK_LOG4CPLUS_TEXT("port") )) {
-        tstring tmp = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("port") );
-        port = atoi(DCMTK_LOG4CPLUS_TSTRING_TO_STRING(tmp).c_str());
-    }
+    properties.getUInt (port, DCMTK_LOG4CPLUS_TEXT("port"));
     serverName = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ServerName") );
 
     openSocket();
@@ -174,10 +178,11 @@ SocketAppender::~SocketAppender()
 // SocketAppender public methods
 //////////////////////////////////////////////////////////////////////////////
 
-void
+void 
 SocketAppender::close()
 {
-    getLogLog().debug(DCMTK_LOG4CPLUS_TEXT("Entering SocketAppender::close()..."));
+    helpers::getLogLog().debug(
+        DCMTK_LOG4CPLUS_TEXT("Entering SocketAppender::close()..."));
 
 #if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
     connector->terminate ();
@@ -197,7 +202,7 @@ void
 SocketAppender::openSocket()
 {
     if(!socket.isOpen()) {
-        socket = helpers::Socket(host, port);
+        socket = helpers::Socket(host, OFstatic_cast(unsigned short, port));
     }
 }
 
@@ -227,17 +232,19 @@ SocketAppender::append(const spi::InternalLoggingEvent& event)
     if(!socket.isOpen()) {
         openSocket();
         if(!socket.isOpen()) {
-            getLogLog().error(DCMTK_LOG4CPLUS_TEXT("SocketAppender::append()- Cannot connect to server"));
+            helpers::getLogLog().error(
+                DCMTK_LOG4CPLUS_TEXT(
+                    "SocketAppender::append()- Cannot connect to server"));
             return;
         }
     }
-
 #endif
 
-    helpers::SocketBuffer buffer = helpers::convertToBuffer(event, serverName);
+    helpers::SocketBuffer buffer(DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE - sizeof(unsigned int));
+    helpers::convertToBuffer (buffer, event, serverName);
     helpers::SocketBuffer msgBuffer(DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE);
 
-    msgBuffer.appendSize_t(buffer.getSize());
+    msgBuffer.appendInt(OFstatic_cast(unsigned, buffer.getSize()));
     msgBuffer.appendBuffer(buffer);
 
     bool ret = socket.write(msgBuffer);
@@ -258,14 +265,18 @@ SocketAppender::append(const spi::InternalLoggingEvent& event)
 namespace helpers
 {
 
-SocketBuffer
-convertToBuffer(const spi::InternalLoggingEvent& event,
+
+void
+convertToBuffer(SocketBuffer & buffer,
+    const spi::InternalLoggingEvent& event,
     const tstring& serverName)
 {
-    SocketBuffer buffer(DCMTK_LOG4CPLUS_MAX_MESSAGE_SIZE - sizeof(unsigned int));
-
     buffer.appendByte(DCMTK_LOG4CPLUS_MESSAGE_VERSION);
+#ifndef UNICODE
     buffer.appendByte(1);
+#else
+    buffer.appendByte(2);
+#endif
 
     buffer.appendString(serverName);
     buffer.appendString(event.getLoggerName());
@@ -277,8 +288,7 @@ convertToBuffer(const spi::InternalLoggingEvent& event,
     buffer.appendInt( OFstatic_cast(unsigned int, event.getTimestamp().usec()) );
     buffer.appendString(event.getFile());
     buffer.appendInt(event.getLine());
-
-    return buffer;
+    buffer.appendString(event.getFunction());
 }
 
 
@@ -287,7 +297,7 @@ readFromBuffer(SocketBuffer& buffer)
 {
     unsigned char msgVersion = buffer.readByte();
     if(msgVersion != DCMTK_LOG4CPLUS_MESSAGE_VERSION) {
-        SharedObjectPtr<LogLog> loglog = LogLog::getLogLog();
+        LogLog * loglog = LogLog::getLogLog();
         loglog->warn(DCMTK_LOG4CPLUS_TEXT("readFromBuffer() received socket message with an invalid version"));
     }
 
@@ -297,8 +307,8 @@ readFromBuffer(SocketBuffer& buffer)
     tstring loggerName = buffer.readString(sizeOfChar);
     LogLevel ll = buffer.readInt();
     tstring ndc = buffer.readString(sizeOfChar);
-    if(serverName.length() > 0) {
-        if(ndc.length() == 0) {
+    if(! serverName.empty ()) {
+        if(ndc.empty ()) {
             ndc = serverName;
         }
         else {
@@ -311,20 +321,19 @@ readFromBuffer(SocketBuffer& buffer)
     long usec = buffer.readInt();
     tstring file = buffer.readString(sizeOfChar);
     int line = buffer.readInt();
-
-    return spi::InternalLoggingEvent(loggerName,
-                                                ll,
-                                                ndc,
-                                                message,
-                                                thread,
-                                                Time(sec, usec),
-                                                file,
-                                                line,
-                                                "");
+    tstring function = buffer.readString(sizeOfChar);
+
+    // TODO: Pass MDC through.
+    spi::InternalLoggingEvent ev (loggerName, ll, ndc,
+        MappedDiagnosticContextMap (), message, thread, Time(sec, usec), file,
+        line);
+    ev.setFunction (function);
+    return ev;
 }
 
+
 } // namespace helpers
 
-} // namespace log4cplus
 
-} // namespace dcmtk
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/strccloc.cc b/oflog/libsrc/strccloc.cc
new file mode 100644
index 0000000..32e83f6
--- /dev/null
+++ b/oflog/libsrc/strccloc.cc
@@ -0,0 +1,233 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/streams.h"
+
+#include <locale>
+#include <iterator>
+#include <algorithm>
+#include <cstring>
+#include <cwchar>
+#include <cwctype>
+#include <cctype>
+
+#include <cassert>
+#include "dcmtk/ofstd/ofvector.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+namespace helpers
+{
+
+void clear_mbstate (mbstate_t &);
+
+#ifdef DCMTK_LOG4CPLUS_WORKING_LOCALE
+
+static
+void
+towstring_internal (STD_NAMESPACE wstring & outstr, const char * src, size_t size,
+    STD_NAMESPACE locale const & loc)
+{
+    if (size == 0)
+    {
+        outstr.clear ();
+        return;
+    }
+
+    typedef STD_NAMESPACE codecvt<wchar_t, char, mbstate_t> CodeCvt;
+    const CodeCvt & cdcvt = STD_NAMESPACE use_facet<CodeCvt>(loc);
+    mbstate_t state;
+    clear_mbstate (state);
+
+    char const * from_first = src;
+    size_t const from_size = size;
+    char const * const from_last = from_first + from_size;
+    char const * from_next = from_first;
+
+    OFVector<wchar_t> dest (from_size);
+
+    wchar_t * to_first = &dest.front ();
+    size_t to_size = dest.size ();
+    wchar_t * to_last = to_first + to_size;
+    wchar_t * to_next = to_first;
+
+    CodeCvt::result result;
+    size_t converted = 0;
+    while (true)
+    {
+        result = cdcvt.in (
+            state, from_first, from_last,
+            from_next, to_first, to_last,
+            to_next);
+        // XXX: Even if only half of the input has been converted the
+        // in() method returns CodeCvt::ok. I think it should return
+        // CodeCvt::partial.
+        if ((result == CodeCvt::partial || result == CodeCvt::ok)
+            && from_next != from_last)
+        {
+            to_size = dest.size () * 2;
+            dest.resize (to_size);
+            converted = to_next - to_first;
+            to_first = &dest.front ();
+            to_last = to_first + to_size;
+            to_next = to_first + converted;
+            continue;
+        }
+        else if (result == CodeCvt::ok && from_next == from_last)
+            break;
+        else if (result == CodeCvt::error
+            && to_next != to_last && from_next != from_last)
+        {
+            clear_mbstate (state);
+            ++from_next;
+            from_first = from_next;
+            *to_next = L'?';
+            ++to_next;
+            to_first = to_next;
+        }
+        else
+            break;
+    }
+    converted = to_next - &dest[0];
+
+    outstr.assign (dest.begin (), dest.begin () + converted);
+}
+
+
+STD_NAMESPACE wstring 
+towstring(const tstring& src)
+{
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src.c_str (), src.size (), STD_NAMESPACE locale ());
+    return ret;
+}
+
+
+STD_NAMESPACE wstring 
+towstring(char const * src)
+{
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src, STD_NAMESPACE strlen (src), STD_NAMESPACE locale ());
+    return ret;
+}
+
+
+static
+void
+tostring_internal (tstring & outstr, const wchar_t * src, size_t size,
+    STD_NAMESPACE locale const & loc)
+{
+    if (size == 0)
+    {
+        outstr.clear ();
+        return;
+    }
+
+    typedef STD_NAMESPACE codecvt<wchar_t, char, mbstate_t> CodeCvt;
+    const CodeCvt & cdcvt = STD_NAMESPACE use_facet<CodeCvt>(loc);
+    mbstate_t state;
+    clear_mbstate (state);
+
+    wchar_t const * from_first = src;
+    size_t const from_size = size;
+    wchar_t const * const from_last = from_first + from_size;
+    wchar_t const * from_next = from_first;
+
+    OFVector<char> dest (from_size);
+
+    char * to_first = &dest.front ();
+    size_t to_size = dest.size ();
+    char * to_last = to_first + to_size;
+    char * to_next = to_first;
+
+    CodeCvt::result result;
+    size_t converted = 0;
+    while (from_next != from_last)
+    {
+        result = cdcvt.out (
+            state, from_first, from_last,
+            from_next, to_first, to_last,
+            to_next);
+        // XXX: Even if only half of the input has been converted the
+        // in() method returns CodeCvt::ok with VC8. I think it should
+        // return CodeCvt::partial.
+        if ((result == CodeCvt::partial || result == CodeCvt::ok)
+            && from_next != from_last)
+        {
+            to_size = dest.size () * 2;
+            dest.resize (to_size);
+            converted = to_next - to_first;
+            to_first = &dest.front ();
+            to_last = to_first + to_size;
+            to_next = to_first + converted;
+        }
+        else if (result == CodeCvt::ok && from_next == from_last)
+            break;
+        else if (result == CodeCvt::error
+            && to_next != to_last && from_next != from_last)
+        {
+            clear_mbstate (state);
+            ++from_next;
+            from_first = from_next;
+            *to_next = '?';
+            ++to_next;
+            to_first = to_next;
+        }
+        else
+            break;
+    }
+    converted = to_next - &dest[0];
+
+    outstr.assign (&*dest.begin (), converted);
+}
+
+
+tstring
+tostring(const STD_NAMESPACE wstring& src)
+{
+    tstring ret;
+    tostring_internal (ret, src.c_str (), src.size (), STD_NAMESPACE locale ());
+    return ret;
+}
+
+
+tstring
+tostring(wchar_t const * src)
+{
+    tstring ret;
+    tostring_internal (ret, src, STD_NAMESPACE wcslen (src), STD_NAMESPACE locale ());
+    return ret;
+}
+
+
+#endif // DCMTK_LOG4CPLUS_WORKING_LOCALE
+
+} // namespace helpers
+
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/strcloc.cc b/oflog/libsrc/strcloc.cc
new file mode 100644
index 0000000..f363e0c
--- /dev/null
+++ b/oflog/libsrc/strcloc.cc
@@ -0,0 +1,156 @@
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/helpers/loglog.h"
+
+#include <cstdlib>
+#include <cstring>
+#include <cwchar>
+#include <cassert>
+#include "dcmtk/ofstd/ofvector.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+namespace helpers
+{
+
+
+void clear_mbstate (mbstate_t & mbs);
+
+
+#if defined (DCMTK_LOG4CPLUS_WORKING_C_LOCALE)
+
+static
+void
+tostring_internal (STD_NAMESPACE string & result, wchar_t const * src, size_t size)
+{
+    OFVector<char> result_buf (MB_CUR_MAX);
+
+    wchar_t const * src_it = src;
+    wchar_t const * const src_end_it = src + size;
+
+    mbstate_t mbs;
+    clear_mbstate (mbs);
+
+    result.clear ();
+    result.reserve (size + size / 3 + 1);
+
+    while (src_it != src_end_it)
+    {
+        size_t ret = STD_NAMESPACE wcrtomb (&result_buf[0], *src_it, &mbs);
+        if (ret == OFstatic_cast(size_t, -1))
+        {
+            result.push_back ('?');
+            clear_mbstate (mbs);
+            ++src_it;
+        }
+        else
+        {
+            result.append (result_buf.begin (), result_buf.begin () + ret);
+            ++src_it;
+        }
+    }
+}
+
+
+STD_NAMESPACE string 
+tostring (const STD_NAMESPACE wstring & src)
+{
+    STD_NAMESPACE string ret;
+    tostring_internal (ret, src.c_str (), src.size ());
+    return ret;
+}
+
+
+STD_NAMESPACE string 
+tostring (wchar_t const * src)
+{
+    assert (src);
+    STD_NAMESPACE string ret;
+    tostring_internal (ret, src, wcslen (src));
+    return ret;
+}
+
+
+static
+void
+towstring_internal (STD_NAMESPACE wstring & result, char const * src, size_t size)
+{
+    char const * src_it = src;
+    char const * const src_end_it = src + size;
+
+    mbstate_t mbs;
+    clear_mbstate (mbs);
+
+    result.clear ();
+    result.reserve (size);
+
+    while (src_it != src_end_it)
+    {
+        size_t const n = size - (src - src_it);
+        wchar_t result_char;
+        size_t ret = STD_NAMESPACE mbrtowc (&result_char, src_it, n, &mbs);
+        if (ret > 0)
+        {
+            result.push_back (result_char);
+            src_it += ret;
+        }
+        else
+        {
+            result.push_back (ret == 0 ? L'\0' : L'?') ;
+            clear_mbstate (mbs);
+            ++src_it;
+        }
+    }
+}
+
+
+STD_NAMESPACE wstring 
+towstring (const STD_NAMESPACE string& src)
+{
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src.c_str (), src.size ());
+    return ret;
+}
+
+
+STD_NAMESPACE wstring 
+towstring (char const * src)
+{
+    assert (src);
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src, STD_NAMESPACE strlen (src));
+    return ret;
+}
+
+#endif // DCMTK_LOG4CPLUS_WORKING_C_LOCALE
+
+} // namespace helpers
+
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/strhelp.cc b/oflog/libsrc/strhelp.cc
index 42a0830..ef1a3a5 100644
--- a/oflog/libsrc/strhelp.cc
+++ b/oflog/libsrc/strhelp.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,63 +20,188 @@
 
 #include "dcmtk/oflog/helpers/strhelp.h"
 #include "dcmtk/oflog/streams.h"
-#include "dcmtk/oflog/logmacro.h"
 #include "dcmtk/ofstd/ofstd.h"
+#include "dcmtk/oflog/internal/internal.h"
 
-//#include <iterator>
-//#include <algorithm>
-//#include <cstring>
-//#include <cwchar>
-//#include <cwctype>
-//#include <cctype>
+#include <iterator>
+#include <algorithm>
+#include <cstring>
+#include <cwchar>
+#include <cwctype>
+#include <cctype>
+#include <cassert>
 
-using namespace dcmtk::log4cplus;
-
-#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
 
 namespace dcmtk
 {
+namespace log4cplus
+{
+
+namespace internal
+{
+
+tstring const empty_str;
+
+} // namespace internal
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Global Methods
+//////////////////////////////////////////////////////////////////////////////
+
+#if defined (UNICODE) && defined (DCMTK_LOG4CPLUS_ENABLE_GLOBAL_C_STRING_STREAM_INSERTER)
+
+log4cplus::tostream& 
+operator <<(log4cplus::tostream& stream, const char* str)
+{
+    return (stream << log4cplus::helpers::towstring(str));
+}
 
+#endif
+
+
+namespace dcmtk
+{
 namespace log4cplus
 {
 
-tostringstream _macros_oss;
+namespace helpers
+{
 
-namespace
+void clear_mbstate (mbstate_t & mbs);
+
+void
+clear_mbstate (mbstate_t & mbs)
 {
+    // Initialize/clear mbstate_t type.
+    // XXX: This is just a hack that works. The shape of mbstate_t varies
+    // from single unsigned to char[128]. Without some sort of initialization
+    // the codecvt::in/out methods randomly fail because the initial state is
+    // random/invalid.
+    memset (&mbs, 0, sizeof (mbstate_t));
+}
 
-static tostringstream const _macros_oss_defaults;
 
-} // namespace
+#if defined (DCMTK_LOG4CPLUS_POOR_MANS_CHCONV)
 
-void _clear_tostringstream (tostringstream & os)
-{
-    os.clear ();
-    os.str ("");
-    os.setf (_macros_oss_defaults.flags ());
-    os.fill (_macros_oss_defaults.fill ());
-    os.precision (_macros_oss_defaults.precision ());
-    os.width (_macros_oss_defaults.width ());
-#if defined (DCMTK_LOG4CPLUS_WORKING_LOCALE)
-    STD_NAMESPACE locale glocale = STD_NAMESPACE locale ();
-    if (os.getloc () != glocale)
-        os.imbue (glocale);
-#endif // defined (DCMTK_LOG4CPLUS_WORKING_LOCALE)
+static
+void
+tostring_internal (OFString & ret, wchar_t const * src, size_t size)
+{
+    ret.resize(size);
+    for (size_t i = 0; i < size; ++i)
+    {
+        STD_NAMESPACE char_traits<wchar_t>::int_type src_int
+            = STD_NAMESPACE char_traits<wchar_t>::to_int_type (src[i]);
+        ret[i] = src_int <= 127
+            ? STD_NAMESPACE char_traits<char>::to_char_type (src_int)
+            : '?';
+    }
 }
 
-} // namespace log4cplus
 
-} // namespace dcmtk
+OFString
+tostring(const STD_NAMESPACE wstring& src)
+{
+    OFString ret;
+    tostring_internal (ret, src.c_str (), src.size ());
+    return ret;
+}
+
 
+OFString
+tostring(wchar_t const * src)
+{
+    assert (src);
+    OFString ret;
+    tostring_internal (ret, src, wcslen (src));
+    return ret;
+}
+
+
+static
+void
+towstring_internal (STD_NAMESPACE wstring & ret, char const * src, size_t size)
+{
+    ret.resize(size);
+    for (size_t i = 0; i < size; ++i)
+    {
+        STD_NAMESPACE char_traits<char>::int_type src_int
+            = STD_NAMESPACE char_traits<char>::to_int_type (src[i]);
+        ret[i] = src_int <= 127
+            ? STD_NAMESPACE char_traits<wchar_t>::to_char_type (src_int)
+            : L'?';
+    }
+}
+
+
+STD_NAMESPACE wstring towstring(const STD_NAMESPACE string& src);
+
+STD_NAMESPACE wstring 
+towstring(const STD_NAMESPACE string& src)
+{
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src.c_str (), src.size ());
+    return ret;
+}
+
+
+STD_NAMESPACE wstring 
+towstring(char const * src)
+{
+    assert (src);
+    STD_NAMESPACE wstring ret;
+    towstring_internal (ret, src, strlen (src));
+    return ret;
+}
+
+#endif // DCMTK_LOG4CPLUS_POOR_MANS_CHCONV
+
+
+namespace
+{
+
+
+struct toupper_func
+{
+    tchar
+    operator () (tchar ch) const
+    {
+        return STD_NAMESPACE char_traits<tchar>::to_char_type (
+#ifdef UNICODE
+            STD_NAMESPACE towupper
+#else
+            toupper
 #endif
+            (STD_NAMESPACE char_traits<tchar>::to_int_type (ch)));
+    }
+};
 
 
-//////////////////////////////////////////////////////////////////////////////
-// Global Methods
-//////////////////////////////////////////////////////////////////////////////
+struct tolower_func
+{
+    tchar
+    operator () (tchar ch) const
+    {
+        return STD_NAMESPACE char_traits<tchar>::to_char_type (
+#ifdef UNICODE
+            STD_NAMESPACE towlower
+#else
+            tolower
+#endif
+            (STD_NAMESPACE char_traits<tchar>::to_int_type (ch)));
+    }
+};
+
+
+} // namespace
+
 
 tstring
-helpers::toUpper(const tstring& s)
+toUpper(const tstring& s)
 {
     OFString tmp;
     return OFStandard::toUpper(tmp, s);
@@ -84,8 +209,14 @@ helpers::toUpper(const tstring& s)
 
 
 tstring
-helpers::toLower(const tstring& s)
+toLower(const tstring& s)
 {
     OFString tmp;
     return OFStandard::toLower(tmp, s);
 }
+
+
+} // namespace helpers
+
+} // namespace log4cplus
+} // end namespace dcmtk
